/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using com.db4o.query;

namespace com.db4o.test.cs
{
	/// <summary>
	/// Summary description for CsEvaluationDelegate.
	/// </summary>
	public class CsEvaluationDelegate
	{
        internal CsEvaluationDelegate child;
        internal String name;
      
        public void store() {
            Tester.deleteAllInstances(this);
            name = "one";
            Tester.store(this);
            CsEvaluationDelegate se1 = new CsEvaluationDelegate();
            se1.child = new CsEvaluationDelegate();
            se1.child.name = "three";
            se1.name = "two";
            Tester.store(se1);
        }
      
        public void testStaticMethodDelegate() {
            runEvaluationDelegateTest(new EvaluationDelegate(_evaluate));
        }
        
        public void testInstanceMethodDelegate() {
            runEvaluationDelegateTest(new EvaluationDelegate(new NameCondition("three")._evaluate));
        }
        
        void runEvaluationDelegateTest(EvaluationDelegate evaluation) {
	        Query q1 = Tester.query();
            Query cq1 = q1;
            q1.constrain(j4o.lang.Class.getClassForObject(this));
            cq1 = cq1.descend("child");
            cq1.constrain(evaluation);
            ObjectSet os = q1.execute();
            Tester.ensure(os.size() == 1);
            CsEvaluationDelegate se = (CsEvaluationDelegate)os.next();
            Tester.ensure(se.name.Equals("two"));
        }

        public static void _evaluate(Candidate candidate) {
            CsEvaluationDelegate obj = ((CsEvaluationDelegate)candidate.getObject());
			candidate.include(obj.name.Equals("three"));
        }
        
        class NameCondition {
        	string _name;
        	
        	public NameCondition(string name) {
        		_name = name;
        	}
        	
        	public void _evaluate(Candidate candidate) {
        		CsEvaluationDelegate obj = ((CsEvaluationDelegate)candidate.getObject());
				candidate.include(obj.name.Equals(_name));
        	}
        }
    }
}
